﻿Option Strict On
Imports System.Collections.ObjectModel
Imports System.Windows.Media

Public Class MP3FileInfoVM
    Friend ReadOnly ModelObjekt As New MP3FileInfo

    Public Sub New()
        'AddHandler CueMarkers.CollectionChanged, AddressOf UpdateCueMarkers
    End Sub

    Public Sub New(varDateiname As String, varTracknummer As String, varInterpret As String, varAlbum As String, varMusiktitel As String, varDauer As TimeSpan, varJahr As String, varStream As Boolean, varGenre As String, varIsFavorite As Boolean, varCoverArtPfad As String, varBPM As Integer, varKey As String, varTakt As String)
        ModelObjekt = New MP3FileInfo(varDateiname, varTracknummer, varInterpret, varAlbum, varMusiktitel, varDauer, varJahr, varStream, varGenre, varIsFavorite, varCoverArtPfad, varBPM, varKey, varTakt)
        'AddHandler CueMarkers.CollectionChanged, AddressOf UpdateCueMarkers
    End Sub

    Public Sub New(varTrackListID As Integer, varIsPlayingIcon As String, varDateiname As String, varTracknummer As String, varInterpret As String, varAlbum As String, varMusiktitel As String, varDauer As TimeSpan, varJahr As String, varStream As Boolean, varGenre As String, varIsFavorite As Boolean, varCoverArtPfad As String, varBPM As Integer, varKey As String, varTakt As String, varCueMarkers As ObservableCollection(Of CueMarkersViewModel))
        ModelObjekt = New MP3FileInfo(varTrackListID, varIsPlayingIcon, varDateiname, varTracknummer, varInterpret, varAlbum, varMusiktitel, varDauer, varJahr, varStream, varGenre, varIsFavorite, varCoverArtPfad, varBPM, varKey, varTakt)
        CueMarkers = varCueMarkers
        'AddHandler CueMarkers.CollectionChanged, AddressOf UpdateCueMarkers
    End Sub

    Friend Sub New(_ModelObjekt As MP3FileInfo)
        ModelObjekt = _ModelObjekt
    End Sub

    Public Property TrackListID As Integer
        Get
            Return ModelObjekt.TrackListID
        End Get
        Set(value As Integer)
            ModelObjekt.TrackListID = value
            Debug.WriteLine("TrackListID geändert!!")
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property IsPlayingIcon As String
        Get
            Return ModelObjekt.IsPlayingIcon
        End Get
        Set(value As String)
            ModelObjekt.IsPlayingIcon = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Dateiname As String
        Get
            Return ModelObjekt.Dateiname
        End Get
        Set(value As String)
            ModelObjekt.Dateiname = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Tracknummer As String
        Get
            Return ModelObjekt.Tracknummer
        End Get
        Set(value As String)
            ModelObjekt.Tracknummer = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Interpret As String
        Get
            Return ModelObjekt.Interpret
        End Get
        Set(value As String)
            ModelObjekt.Interpret = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Album As String
        Get
            Return ModelObjekt.Album
        End Get
        Set(value As String)
            ModelObjekt.Album = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Musiktitel As String
        Get
            Return ModelObjekt.Musiktitel
        End Get
        Set(value As String)
            ModelObjekt.Musiktitel = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Dauer As TimeSpan
        Get
            Return ModelObjekt.Dauer
        End Get
        Set(value As TimeSpan)
            ModelObjekt.Dauer = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Jahr As String
        Get
            Return ModelObjekt.Jahr
        End Get
        Set(value As String)
            ModelObjekt.Jahr = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Stream As Boolean
        Get
            Return ModelObjekt.Stream
        End Get
        Set(value As Boolean)
            ModelObjekt.Stream = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Genre As String
        Get
            Return ModelObjekt.Genre
        End Get
        Set(value As String)
            ModelObjekt.Genre = value
            ' RaisePropertyChanged()
        End Set
    End Property

    Public Property IsFavorite As Boolean
        Get
            Return ModelObjekt.IsFavorite
        End Get
        Set(value As Boolean)
            ModelObjekt.IsFavorite = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property CoverArtPfad As String
        Get
            Return ModelObjekt.CoverArtPfad
        End Get
        Set(value As String)
            ModelObjekt.CoverArtPfad = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property BPM As Integer
        Get
            Return ModelObjekt.BPM
        End Get
        Set(value As Integer)
            ModelObjekt.BPM = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Key As String
        Get
            Return ModelObjekt.Key
        End Get
        Set(value As String)
            ModelObjekt.Key = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property Takt As String
        Get
            Return ModelObjekt.Takt
        End Get
        Set(value As String)
            ModelObjekt.Takt = value
            'RaisePropertyChanged()
        End Set
    End Property

    Private _CueMarkers As ObservableCollection(Of CueMarkersViewModel)
    Public Property CueMarkers As ObservableCollection(Of CueMarkersViewModel)
        Get
            Return _CueMarkers
        End Get
        Set(value As ObservableCollection(Of CueMarkersViewModel))
            _CueMarkers = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property GehoertZuAlbum As Boolean
        Get
            Return ModelObjekt.GehoertZuAlbum
        End Get
        Set(value As Boolean)
            ModelObjekt.GehoertZuAlbum = value
            'RaisePropertyChanged()
        End Set
    End Property

    Public Property GenFN As String
        Get
            Return ModelObjekt.GenFN
        End Get
        Set(value As String)
            ModelObjekt.GenFN = value
            'RaisePropertyChanged()
        End Set
    End Property


End Class


Public Class MP3FileInfo

    Public Property TrackListID As Integer
    Public Property IsPlayingIcon As String
    Public Property Dateiname As String
    Public Property Tracknummer As String
    Public Property Interpret As String
    Public Property Album As String
    Public Property Musiktitel As String
    Public Property Dauer As TimeSpan
    Public Property Jahr As String
    Public Property Stream As Boolean
    Public Property Genre As String
    Public Property IsFavorite As Boolean
    Public Property CoverArtPfad As String
    Public Property BPM As Integer
    Public Property Key As String
    Public Property Takt As String

    Public Property GehoertZuAlbum As Boolean

    Public Property GenFN As String

    'Public Property CueMarkers As ObservableCollection(Of ViewModel.CueMarkersViewModel)


    Public Sub New(varDateiname As String, varTracknummer As String, varInterpret As String, varAlbum As String, varMusiktitel As String, varDauer As TimeSpan, varJahr As String, varStream As Boolean, varGenre As String, varIsFavorite As Boolean, varCoverArtPfad As String, varBPM As Integer, varKey As String, varTakt As String)
        Dateiname = varDateiname
        Tracknummer = varTracknummer
        Interpret = varInterpret
        Album = varAlbum
        Musiktitel = varMusiktitel
        Dauer = varDauer
        Jahr = varJahr
        Stream = varStream
        Genre = varGenre
        IsFavorite = varIsFavorite
        CoverArtPfad = varCoverArtPfad
        BPM = varBPM
        Key = varKey
        Takt = varTakt
    End Sub

    Public Sub New(varTrackListID As Integer, varIsPlayingIcon As String, varDateiname As String, varTracknummer As String, varInterpret As String, varAlbum As String, varMusiktitel As String, varDauer As TimeSpan, varJahr As String, varStream As Boolean, varGenre As String, varIsFavorite As Boolean, varCoverArtPfad As String, varBPM As Integer, varKey As String, varTakt As String)
        TrackListID = varTrackListID
        IsPlayingIcon = varIsPlayingIcon
        Dateiname = varDateiname
        Tracknummer = varTracknummer
        Interpret = varInterpret
        Album = varAlbum
        Musiktitel = varMusiktitel
        Dauer = varDauer
        Jahr = varJahr
        Stream = varStream
        Genre = varGenre
        IsFavorite = varIsFavorite
        CoverArtPfad = varCoverArtPfad
        BPM = varBPM
        Key = varKey
        Takt = varTakt
        'CueMarkers = New ObservableCollection(Of Model.CueMarkersModel)
    End Sub

    Public Sub New()

    End Sub
End Class

Public Class CueMarkersViewModel


    Public Sub New()

    End Sub

    'Private ErmittelteFarben As New ObservableCollection(Of ColorInfo)(From [property] In GetType(System.Windows.Media.Colors).GetProperties() Order By [property].Name Select New ColorInfo([property].Name, CType([property].GetValue(Nothing, Nothing), System.Windows.Media.Color)))
    'Public Sub New(argName As String, argFarbe As ColorInfo, argPosition As TimeSpan, argFarbIndex As Integer)
    Public Sub New(argName As String, argPosition As TimeSpan, argFarbIndex As Integer)
        Name = argName
        'Farbe = argFarbe
        Position = argPosition
        FarbIndex = argFarbIndex
    End Sub

    'Friend Sub New(_ModelObjekt As Model.CueMarkersModel)
    '    ModelObjekt = _ModelObjekt
    'End Sub

    Private _Name As String
    Public Property Name As String
        Get
            Return _Name
        End Get
        Set(value As String)
            _Name = value
            'RaisePropertyChanged()
        End Set
    End Property

    'Private _Farbe As ColorInfo
    'Public Property Farbe As ColorInfo
    '    Get
    '        Return ErmittelteFarben(FarbIndex)
    '    End Get
    '    Set(value As ColorInfo)
    '        _Farbe = value
    '        FarbIndex = ErmittelteFarben.IndexOf(value)
    '        'RaisePropertyChanged()
    '    End Set
    'End Property

    Private _Position As TimeSpan
    Public Property Position As TimeSpan
        Get
            Return _Position
        End Get
        Set(value As TimeSpan)
            _Position = value
            'RaisePropertyChanged()
        End Set
    End Property

    Private _FarbIndex As Integer
    Public Property FarbIndex As Integer
        Get
            Return _FarbIndex

        End Get
        Set(value As Integer)
            _FarbIndex = value
            'RaisePropertyChanged()
        End Set
    End Property
End Class

'Public Class ColorInfo
'    Public Property ColorName As String
'    'Public Property Farbe As Color

'    'Public ReadOnly Property SampleBrush As SolidColorBrush
'    '    Get
'    '        Return New SolidColorBrush(Farbe)
'    '    End Get
'    'End Property

'    Public ReadOnly Property HexValue As String
'        Get
'            Return Farbe.ToString()
'        End Get
'    End Property



'    Public Sub New(ByVal color_name As String, ByVal color As Color)
'        ColorName = color_name
'        Farbe = color
'    End Sub
'End Class

